<a id="mypy-boto3-athena"></a>

# mypy-boto3-athena

[![PyPI - mypy-boto3-athena](https://img.shields.io/pypi/v/mypy-boto3-athena.svg?color=blue)](https://pypi.org/project/mypy-boto3-athena)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-athena.svg?color=blue)](https://pypi.org/project/mypy-boto3-athena)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-athena?color=blue)](https://pypistats.org/packages/mypy-boto3-athena)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.Athena 1.18.31](https://boto3.amazonaws.com/v1/documentation/api/1.18.31/reference/services/athena.html#Athena)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 5.1.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-athena docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_athena/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-athena](#mypy-boto3-athena)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `Athena` service.

```bash
python -m pip install boto3-stubs[athena]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[athena]` in your environment:
  `python -m pip install 'boto3-stubs[athena]'`

Both type checking and auto-complete should work for `Athena` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[athena]` in your environment:
  `python -m pip install 'boto3-stubs[athena]'`

Both type checking and auto-complete should work for `Athena` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[athena]` in your environment:
  `python -m pip install 'boto3-stubs[athena]'`
- Run `mypy` as usual

Type checking should work for `Athena` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[athena]` in your environment:
  `python -m pip install 'boto3-stubs[athena]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Athena` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AthenaClient` provides annotations for `boto3.client("athena")`.

```python
import boto3

from mypy_boto3_athena import AthenaClient

client: AthenaClient = boto3.client("athena")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AthenaClient = session.client("athena")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_athena.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_athena import AthenaClient
from mypy_boto3_athena.paginator import (
    GetQueryResultsPaginator,
    ListDataCatalogsPaginator,
    ListDatabasesPaginator,
    ListNamedQueriesPaginator,
    ListQueryExecutionsPaginator,
    ListTableMetadataPaginator,
    ListTagsForResourcePaginator,
)

client: AthenaClient = boto3.client("athena")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_query_results_paginator: GetQueryResultsPaginator = client.get_paginator("get_query_results")
list_data_catalogs_paginator: ListDataCatalogsPaginator = client.get_paginator("list_data_catalogs")
list_databases_paginator: ListDatabasesPaginator = client.get_paginator("list_databases")
list_named_queries_paginator: ListNamedQueriesPaginator = client.get_paginator("list_named_queries")
list_query_executions_paginator: ListQueryExecutionsPaginator = client.get_paginator("list_query_executions")
list_table_metadata_paginator: ListTableMetadataPaginator = client.get_paginator("list_table_metadata")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```

<a id="literals"></a>

### Literals

`mypy_boto3_athena.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_athena.literals import (
    ColumnNullableType,
    DataCatalogTypeType,
    EncryptionOptionType,
    GetQueryResultsPaginatorName,
    ListDataCatalogsPaginatorName,
    ListDatabasesPaginatorName,
    ListNamedQueriesPaginatorName,
    ListQueryExecutionsPaginatorName,
    ListTableMetadataPaginatorName,
    ListTagsForResourcePaginatorName,
    QueryExecutionStateType,
    StatementTypeType,
    WorkGroupStateType,
)

def check_value(value: ColumnNullableType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_athena.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_athena.type_defs import (
    BatchGetNamedQueryInputRequestTypeDef,
    BatchGetNamedQueryOutputTypeDef,
    BatchGetQueryExecutionInputRequestTypeDef,
    BatchGetQueryExecutionOutputTypeDef,
    ColumnInfoTypeDef,
    ColumnTypeDef,
    CreateDataCatalogInputRequestTypeDef,
    CreateNamedQueryInputRequestTypeDef,
    CreateNamedQueryOutputTypeDef,
    CreatePreparedStatementInputRequestTypeDef,
    CreateWorkGroupInputRequestTypeDef,
    DataCatalogSummaryTypeDef,
    DataCatalogTypeDef,
    DatabaseTypeDef,
    DatumTypeDef,
    DeleteDataCatalogInputRequestTypeDef,
    DeleteNamedQueryInputRequestTypeDef,
    DeletePreparedStatementInputRequestTypeDef,
    DeleteWorkGroupInputRequestTypeDef,
    EncryptionConfigurationTypeDef,
    EngineVersionTypeDef,
    GetDataCatalogInputRequestTypeDef,
    GetDataCatalogOutputTypeDef,
    GetDatabaseInputRequestTypeDef,
    GetDatabaseOutputTypeDef,
    GetNamedQueryInputRequestTypeDef,
    GetNamedQueryOutputTypeDef,
    GetPreparedStatementInputRequestTypeDef,
    GetPreparedStatementOutputTypeDef,
    GetQueryExecutionInputRequestTypeDef,
    GetQueryExecutionOutputTypeDef,
    GetQueryResultsInputRequestTypeDef,
    GetQueryResultsOutputTypeDef,
    GetTableMetadataInputRequestTypeDef,
    GetTableMetadataOutputTypeDef,
    GetWorkGroupInputRequestTypeDef,
    GetWorkGroupOutputTypeDef,
    ListDataCatalogsInputRequestTypeDef,
    ListDataCatalogsOutputTypeDef,
    ListDatabasesInputRequestTypeDef,
    ListDatabasesOutputTypeDef,
    ListEngineVersionsInputRequestTypeDef,
    ListEngineVersionsOutputTypeDef,
    ListNamedQueriesInputRequestTypeDef,
    ListNamedQueriesOutputTypeDef,
    ListPreparedStatementsInputRequestTypeDef,
    ListPreparedStatementsOutputTypeDef,
    ListQueryExecutionsInputRequestTypeDef,
    ListQueryExecutionsOutputTypeDef,
    ListTableMetadataInputRequestTypeDef,
    ListTableMetadataOutputTypeDef,
    ListTagsForResourceInputRequestTypeDef,
    ListTagsForResourceOutputTypeDef,
    ListWorkGroupsInputRequestTypeDef,
    ListWorkGroupsOutputTypeDef,
    NamedQueryTypeDef,
    PaginatorConfigTypeDef,
    PreparedStatementSummaryTypeDef,
    PreparedStatementTypeDef,
    QueryExecutionContextTypeDef,
    QueryExecutionStatisticsTypeDef,
    QueryExecutionStatusTypeDef,
    QueryExecutionTypeDef,
    ResponseMetadataTypeDef,
    ResultConfigurationTypeDef,
    ResultConfigurationUpdatesTypeDef,
    ResultSetMetadataTypeDef,
    ResultSetTypeDef,
    RowTypeDef,
    StartQueryExecutionInputRequestTypeDef,
    StartQueryExecutionOutputTypeDef,
    StopQueryExecutionInputRequestTypeDef,
    TableMetadataTypeDef,
    TagResourceInputRequestTypeDef,
    TagTypeDef,
    UnprocessedNamedQueryIdTypeDef,
    UnprocessedQueryExecutionIdTypeDef,
    UntagResourceInputRequestTypeDef,
    UpdateDataCatalogInputRequestTypeDef,
    UpdatePreparedStatementInputRequestTypeDef,
    UpdateWorkGroupInputRequestTypeDef,
    WorkGroupConfigurationTypeDef,
    WorkGroupConfigurationUpdatesTypeDef,
    WorkGroupSummaryTypeDef,
    WorkGroupTypeDef,
)

def get_structure() -> BatchGetNamedQueryInputRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-athena` version is the same as related `boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-athena docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_athena/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
